# Class StateEdit

java.lang.Object
javax.swing.undo.AbstractUndoableEdit
javax.swing.undo.StateEdit

All Implemented Interfaces:
  `Serializable, UndoableEdit`

public class StateEdit extends AbstractUndoableEdit

StateEdit is a general edit for objects that change state. Objects being edited must conform to the StateEditable interface.

This edit class works by asking an object to store it's state in Hashtables before and after editing occurs. Upon undo or redo the object is told to restore it's state from these Hashtables.

A state edit is used as follows:

         // Create the edit during the "before" state of the object
         StateEdit newEdit = new StateEdit(myObject);
         // Modify the object
         myObject.someStateModifyingMethod();
         // "end" the edit when you are done modifying the object
         newEdit.end();

Note that when a StateEdit ends, it removes redundant state from the Hashtables - A state Hashtable is not guaranteed to contain all keys/values placed into it when the state is stored!

See Also:
  - `StateEditable`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected StateEditable`
`object`
The object being edited
`protected Hashtable<Object,Object>`
`postState`
The state information after the edit
`protected Hashtable<Object,Object>`
`preState`
The state information prior to the edit
`protected static final String`
`RCSID`
Obsolete RCS version identity.
`protected String`
`undoRedoName`
The undo/redo presentation name

### Fields declared in class AbstractUndoableEdit

`RedoName, UndoName`
Modifier and Type
Field
Description
`protected static final String`
`RedoName`
String returned by `getRedoPresentationName`; as of Java 2 platform v1.3.1 this field is no longer used.
`protected static final String`
`UndoName`
String returned by `getUndoPresentationName`; as of Java 2 platform v1.3.1 this field is no longer used.

## Constructor Summary

Constructors
Constructor
Description
`StateEdit(StateEditable anObject)`
Create and return a new StateEdit.
`StateEdit(StateEditable anObject, String name)`
Create and return a new StateEdit with a presentation name.

## Method Summary

Modifier and Type
Method
Description
`void`
`end()`
Gets the post-edit state of the StateEditable object and ends the edit.
`String`
`getPresentationName()`
Gets the presentation name for this edit
`protected void`
`init(StateEditable anObject, String name)`
Initialize the state edit.
`void`
`redo()`
Tells the edited object to apply the state after the edit
`protected void`
`removeRedundantState()`
Remove redundant key/values in state hashtables.
`void`
`undo()`
Tells the edited object to apply the state prior to the edit

### Methods declared in class AbstractUndoableEdit

`addEdit, canRedo, canUndo, die, getRedoPresentationName, getUndoPresentationName, isSignificant, replaceEdit, toString`
Modifier and Type
Method
Description
`boolean`
`addEdit(UndoableEdit anEdit)`
This default implementation returns false.
`boolean`
`canRedo()`
Returns `true` if this edit is `alive` and `hasBeenDone` is `false`.
`boolean`
`canUndo()`
Returns true if this edit is `alive` and `hasBeenDone` is `true`.
`void`
`die()`
Sets `alive` to false.
`String`
`getRedoPresentationName()`
Retrieves the value from the defaults table with key `AbstractUndoableEdit.redoText` and returns that value followed by a space, followed by `getPresentationName`.
`String`
`getUndoPresentationName()`
Retrieves the value from the defaults table with key `AbstractUndoableEdit.undoText` and returns that value followed by a space, followed by `getPresentationName`.
`boolean`
`isSignificant()`
This default implementation returns true.
`boolean`
`replaceEdit(UndoableEdit anEdit)`
This default implementation returns false.
`String`
`toString()`
Returns a string that displays and identifies this object's properties.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Field Details

### RCSID

protected static final String RCSID
Obsolete RCS version identity.

See Also:
  - Constant Field Values

### object

protected StateEditable object
The object being edited

### preState

protected Hashtable<Object,Object> preState
The state information prior to the edit

### postState

protected Hashtable<Object,Object> postState
The state information after the edit

### undoRedoName

protected String undoRedoName
The undo/redo presentation name

## Constructor Details

### StateEdit

public StateEdit(StateEditable anObject)
Create and return a new StateEdit.

Parameters:
  `anObject` - The object to watch for changing state
See Also:
  - `StateEdit`

### StateEdit

public StateEdit(StateEditable anObject, String name)
Create and return a new StateEdit with a presentation name.

Parameters:
  `anObject` - The object to watch for changing state
  `name` - The presentation name to be used for this edit
See Also:
  - `StateEdit`

## Method Details

### init

protected void init(StateEditable anObject, String name)
Initialize the state edit.

Parameters:
  `anObject` - The object to watch for changing state
  `name` - The presentation name to be used for this edit

### end

public void end()
Gets the post-edit state of the StateEditable object and ends the edit.

### undo

public void undo()
Tells the edited object to apply the state prior to the edit

Specified by:
  `undo` in interface `UndoableEdit`
Overrides:
  `undo` in class `AbstractUndoableEdit`
See Also:
  - `AbstractUndoableEdit.canUndo()`

### redo

public void redo()
Tells the edited object to apply the state after the edit

Specified by:
  `redo` in interface `UndoableEdit`
Overrides:
  `redo` in class `AbstractUndoableEdit`
See Also:
  - `AbstractUndoableEdit.canRedo()`

### getPresentationName

public String getPresentationName()
Gets the presentation name for this edit

Specified by:
  `getPresentationName` in interface `UndoableEdit`
Overrides:
  `getPresentationName` in class `AbstractUndoableEdit`
Returns:
  the empty string ""
See Also:
  - `AbstractUndoableEdit.getUndoPresentationName()`
  - `AbstractUndoableEdit.getRedoPresentationName()`

### removeRedundantState

protected void removeRedundantState()
Remove redundant key/values in state hashtables.